//+------------------------------------------------------------------+
//|                                            TickSmoother_v2.1.mq4 |
//|                                Copyright  2009, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Black
#property indicator_color3 Tomato
#property indicator_color4 Aqua
#property indicator_width3 2
#property indicator_width4 2
#property indicator_color5 DodgerBlue
#property indicator_color6 Magenta
//---- buffers
extern int     Price       =     0; //0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted Close
extern int     FastMA      =     5; //Fast MA Length(Period)
extern int     SlowMA      =    14; //Slow MA Length(Period)
extern int     MA_Mode     =     0; //MA Mode: 0-SMA,1-EMA,2-Wilder(SMMA),3-LWMA 
extern int     NumTicks    =     0; //TimeFrame in ticks (=0 if NumSecs  > 0)
extern int     NumSecs     =    10; //TimeFrame in secs  (=0 if NumTicks > 0) 
extern int     MaxBars     =    50; //Max Number of ticks   

double Hi[];
double Lo[];
double tOpen[];
double tClose[];
double Fast[];
double Slow[];
double price[];

int      tickCounter=0, barCounter, pSecs;
datetime pTime;
string   short_name, t;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0, Hi);
   SetIndexStyle(1,DRAW_HISTOGRAM,CLR_NONE);
   SetIndexBuffer(1, Lo);
      if(NumTicks == 1)
      {
      SetIndexStyle(3,DRAW_LINE,0,1);
      }
      else
      {
      SetIndexStyle(2,DRAW_ARROW);
      SetIndexBuffer(2, tOpen);
      SetIndexArrow(2,158); 
      SetIndexStyle(3,DRAW_ARROW);
      SetIndexArrow(3,158); 
      }
   SetIndexBuffer(3, tClose);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, Fast);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5, Slow);
   SetIndexBuffer(6, price);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(NumTicks > 0) t = NumTicks +" Ticks] ";
   if(NumSecs  > 0) t = NumSecs  +" Secs] ";
   short_name="TickSmoother_v2.1 ["+t+"("+Price+","+FastMA+","+SlowMA+","+MA_Mode+","+MaxBars+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Hi");
   SetIndexLabel(1,"Lo");
   SetIndexLabel(2,"Open");
   SetIndexLabel(3,"Close");
   SetIndexLabel(4,"Fast");
   SetIndexLabel(5,"Slow");
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0); 
     
   pTime = Time[0];
   pSecs = TimeCurrent();       
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
//----
   return(0);
}

void ShiftArray(int mode)
{
   if(mode==0)
   {
      for(int cnt=barCounter; cnt >= 0; cnt--)
      {
      Hi [cnt] = Hi[cnt-1];
      Lo [cnt] = Lo[cnt-1];
      tOpen[cnt] = tOpen[cnt-1];
      tClose[cnt] = tClose[cnt-1];
      Fast [cnt] = Fast[cnt-1];
      Slow [cnt] = Slow[cnt-1];
      price [cnt] = price[cnt-1];
      }
   }
   else
   {
      for(cnt=1; cnt <= barCounter; cnt++)
      {
      Hi [cnt-1] = Hi[cnt];
      Lo [cnt-1] = Lo[cnt];
      tOpen[cnt-1] = tOpen[cnt];
      tClose[cnt-1] = tClose[cnt];
      Fast [cnt-1] = Fast[cnt];
      Slow [cnt-1] = Slow[cnt];
      price [cnt-1] = price[cnt];
          
      Hi[cnt]=0.0;
      Lo[cnt]=0.0;
      tOpen[cnt]=0.0;
      tClose[cnt]=0.0;
      Fast[cnt]=0.0;
      Slow[cnt]=0.0;
      price[cnt] = 0.0;
      }
   }
}

bool isNewBar()
{
   bool res=false;
   if (Time[0]!=pTime)
   {
   res=true;
   pTime=Time[0];
   }   

   return(res);
}

double aPrice(int p,int bar)
{
   double result;
   switch(p)
   {
   case 1 : result = tOpen[bar]; break;
   case 2 : result = Hi[bar]; break;
   case 3 : result = Lo[bar]; break;
   case 4 : result = (Hi[bar]+Lo[bar])/2; break;
   case 5 : result = (Hi[bar]+Lo[bar]+tClose[bar])/3; break;
   case 6 : result = (Hi[bar]+Lo[bar]+tClose[bar]+tClose[bar])/4; break;
   default: result = tClose[bar]; 
   }
   
   return(result);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
   
   if(cnt_bars < 1) //tickCounter == 0)
   {
      for(i=Bars-1;i>=0;i--)
      {
      Hi[i] = 0.0;
      Lo[i] = 0.0;
      tOpen[i] = 0.0;
      tClose[i]= 0.0;
      Fast[i] = 0.0;
      Slow[i] = 0.0;
      price[i]= 0.0;
      }
   }
   
   tickCounter++;
   
   bool tcond = false;   
   if(NumTicks > 0 && NumSecs == 0) tcond = tickCounter > 0 && tickCounter % NumTicks == 0;
   if(NumTicks == 0 && NumSecs > 0) tcond = TimeCurrent() >= pSecs + NumSecs;
   
   if(tcond) 
   {
   barCounter ++; 
   if(!isNewBar()) ShiftArray(0);
   tOpen[0]=Bid;
   tClose[0]=Bid;
   Hi[0]=Bid;
   Lo[0]=Bid; 
   price[0] = aPrice(Price,0); 
   if(NumSecs > 0) pSecs = TimeCurrent();
   }
   
   if(barCounter>=1)
   {
   if(isNewBar()) ShiftArray(1);
   tClose[0]=Bid;
   Hi[0]=MathMax(Hi[0],Bid);
   if(Lo[0] > 0) Lo[0]=MathMin(Lo[0],Bid); else Lo[0]=Bid;
   price[0] = aPrice(Price,0); 
   }
   
   if(barCounter >= MaxBars) 
   {
      for(i=MaxBars; i<MaxBars+10;i++)
      { 
      Hi[i]=0.0;
      Lo[i]=0.0;
      tOpen[i]=0.0;
      tClose[i]=0.0;
      Fast[i]=0.0;
      Slow[i]=0.0;
      }
   }
      
   if(MA_Mode == 0)
   {
   if(barCounter > FastMA) Fast[0] = TickSMA(price, FastMA);          
   if(barCounter > SlowMA) Slow[0] = TickSMA(price, SlowMA);
   }   
   else
   if(MA_Mode == 1)
   {
   if(barCounter == FastMA+1) Fast[0] = TickSMA(price,FastMA);  
   else if(barCounter > FastMA+1) Fast[0] = TickEMA(price,Fast,FastMA);
   if(barCounter == SlowMA+1) Slow[0] = TickSMA(price,SlowMA);  
   else if(barCounter > SlowMA+1) Slow[0] = TickEMA(price,Slow,SlowMA);
   }
   else
   if(MA_Mode == 2)
   {
   if(barCounter == 2*FastMA) Fast[0] = TickSMA(price,2*FastMA-1);  
   else if(barCounter > 2*FastMA) Fast[0] = TickEMA(price,Fast,2*FastMA-1);
   if(barCounter == 2*SlowMA) Slow[0] = TickSMA(price,2*SlowMA-1);  
   else if(barCounter > 2*SlowMA) Slow[0] = TickEMA(price,Slow,2*SlowMA-1);
   }
   if(MA_Mode == 3)
   {
   if(barCounter > FastMA) Fast[0] = TickLWMA(price,FastMA);          
   if(barCounter > SlowMA) Slow[0] = TickLWMA(price,SlowMA);
   }   
     
//----
   return(0);
}
//+------------------------------------------------------------------+
double TickSMA(double array[],int per)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) 
   {
   double a = array[i];
   if(array[i]==0) a = Bid;
   Sum += a;
   //if(array[i]==0) Print("i=",i," a=",array[i]);
   }
   return(Sum/per);
}                

double TickEMA(double array1[],double array2[],int per)
{
   return(array2[1] + 2.0/(1+per)*(array1[0] - array2[1]));
}

double TickLWMA(double array[],int per)
{
   double Sum = 0;
   double Weight = 0;
   
      for(int i = 0;i < per;i++)
      { 
      Weight+= (per - i);
      Sum += array[i]*(per - i);
      }
   if(Weight>0) double lwma = Sum/Weight;
   else lwma = 0; 
   return(lwma);
}                          